// ChatCDoc.cpp : implementation of the CChatCDoc class
//

#include "stdafx.h"
#include "ChatC.h"

#include "ChatCDoc.h"
#include "ClientSock.h"
#include "ChatCView.h"
#include "ProtocolUnit.h"
#include "DialogConnect.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CChatCDoc

IMPLEMENT_DYNCREATE(CChatCDoc, CDocument)

BEGIN_MESSAGE_MAP(CChatCDoc, CDocument)
	//{{AFX_MSG_MAP(CChatCDoc)
		// NOTE - the ClassWizard will add and remove mapping macros here.
		//    DO NOT EDIT what you see in these blocks of generated code!
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CChatCDoc construction/destruction

CChatCDoc::CChatCDoc()
{
	// TODO: add one-time construction code here
	m_pClientSock=NULL;
	m_sNickPropos="";
	m_bServer=FALSE;
	m_bDownCmd=FALSE;
}


CChatCDoc::~CChatCDoc()
{
}


BOOL CChatCDoc::OnNewDocument()
{
	if (!CDocument::OnNewDocument())
		return FALSE;

	POSITION pos  = GetFirstViewPosition();
	ASSERT(pos!=NULL);
	m_pView = (CChatCView*) GetNextView(pos);
	ASSERT(m_pView!=NULL);

	return TRUE;
}


/////////////////////////////////////////////////////////////////////////////
// CChatCDoc serialization

void CChatCDoc::Serialize(CArchive& ar)
{
	if (ar.IsStoring())
	{
		// TODO: add storing code here
	}
	else
	{
		// TODO: add loading code here
	}
}

/////////////////////////////////////////////////////////////////////////////
// CChatCDoc diagnostics

#ifdef _DEBUG
void CChatCDoc::AssertValid() const
{
	CDocument::AssertValid();
}

void CChatCDoc::Dump(CDumpContext& dc) const
{
	CDocument::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CChatCDoc commands



void CChatCDoc::ReceiveFromServer()
{
	CProtocolUnit unit;   
	unit.Extract(m_pClientSock->GetBuffer()); 

	switch(unit.GetCommandID())
	{
		case PU_ERROR:
		{
			if (unit.GetParam()=="0")				//unknown command dostal server
			{
				m_pView->m_sSaid += "unknown command! \r\n";
				m_pView->UpdateData(FALSE);
			}
			if (unit.GetParam()=="1")  //nick already is
			{
				m_pClientSock->SetClientNick("");
				m_pView->m_sSaid += "Nick in use! please try again\r\n";
				m_pView->UpdateData(FALSE);
				m_pView->WrongNickWasChosen();
		
			}
			if (unit.GetParam()=="2")				
			{
				m_pView->m_sSaid += "Remember to use JOIN first.\r\n";
				m_pClientSock->SetClientNick("");
				m_pClientSock->SetJoined(FALSE);
				m_pView->UpdateData(FALSE);
			}
			if (unit.GetParam()=="3")    //chce whisper a takiego nicka nie ma
			{
				m_pView->m_sSaid += "There is no: " + unit.GetText()+" here.\r\n";
				m_pView->UpdateData(FALSE);
			}
			break;
		}
		case PU_JOIN:
		{
			if (unit.GetParam()==m_sNickPropos)  //dostalismy potwierdzenie JOIN dla nas
			{
				m_pClientSock->SetJoined(TRUE);
				m_pClientSock->SetClientNick(unit.GetParam());
				m_pView->m_sSaid+="You JOINED the discussion\r\n";	
				m_pView->m_nick_show=m_pClientSock->GetClientNick();
				m_pView->m_say_control.SetFocus();
				m_pView->UpdateData(FALSE);
				NickListRequest();  //zeby uaktualnic liste nickow
			}
			else
			{
				m_pView->m_sSaid+=unit.GetParam()+" "+unit.GetText()+"\r\n";
				m_pView->m_say_control.SetFocus();
				m_pView->UpdateData(FALSE);
				NickListRequest();
			}
			break;
		}
		case PU_SAY:
		{
			CString cMesg;
			cMesg="<"+unit.GetParam() + ">: " + unit.GetText()+"\r\n";
			m_pView->m_sSaid+=cMesg;
			m_pView->m_say_control.SetFocus();
			m_pView->UpdateData(FALSE);
			break;
		}
		case PU_NICK:
		{
			//m_pView->m_sSaid+="unit.param:"+unit.GetParam()+"\r\n";
			//m_pView->m_sSaid+="nick propos"+m_sNickPropos+"\r\n";
			//m_pView->UpdateData(FALSE);
			if (unit.GetText()==m_sNickPropos)  //dostalismy potwierdzenie nick dla nas
			{
				m_pClientSock->SetJoined(TRUE);
				m_pClientSock->SetClientNick(unit.GetText());
				m_pView->m_sSaid+=unit.GetParam()+" is known as "+unit.GetText()+"\r\n";
				m_pView->UpdateData(FALSE);
				m_pView->m_nick_show=m_pClientSock->GetClientNick();
				m_pView->m_say_control.SetFocus();
				m_pView->UpdateData(FALSE);
				NickListRequest();  //zeby uaktualnic liste nickow
			}
			else
			{
				m_pView->m_sSaid+=unit.GetParam()+" is known as "+unit.GetText()+"\r\n";
				m_pView->m_say_control.SetFocus();
				m_pView->UpdateData(FALSE);
				NickListRequest();
			}
			break;
		}
		case PU_WHISPER:
		{
			m_pView->m_sSaid+="!!!<"+unit.GetParam()+">: "+unit.GetText()+"\r\n";
		  m_pView->m_say_control.SetFocus();
			m_pView->UpdateData(FALSE);
			break;
		}
		case PU_WELCOME:
		{
			m_pView->m_sSaid+="You are CONNECTED\r\n";
			m_pView->UpdateData(FALSE);
			NickListRequest();
			m_pClientSock->SetJoined(FALSE);
			m_bServer=TRUE;
			break;
		}
		case PU_DOWN:
		{
			m_pView->m_sSaid+="Server is going down......\r\n";
			m_pView->m_nick_list.ResetContent();
			m_pView->m_nick_show="";
			m_bDownCmd=TRUE;
			m_pView->UpdateData(FALSE);
			break;
		}
		case PU_BYE:
		{
			if (unit.GetParam()==m_sNickPropos)  //dostalismy potwierdzenie bye dla nas
			{
				m_pClientSock->SetJoined(FALSE);
				m_pClientSock->SetClientNick("");
				m_pView->m_nick_show="";
				m_pView->m_say_control.SetFocus();
				m_pView->UpdateData(FALSE);
				NickListRequest();  //zeby nie blo nas juz na liscie nickow
			}
			else
			{
				m_pView->m_sSaid+=unit.GetParam()+" said BYE\r\n";
				m_pView->m_say_control.SetFocus();
				m_pView->UpdateData(FALSE);
				NickListRequest();  //trzeba nowe nicki, bo ktos sie odlaczyl
			}
			break;
		}

		case PU_DISCONNECT:
		 {
			 	m_pView->m_sSaid+=unit.GetParam()+" DISCONNECTED\r\n";
				m_pView->UpdateData(FALSE);
				NickListRequest();  //trzeba nowe nicki, bo ktos sie odlaczyl
			 break;
		 }
		case PU_LIST:
		{
			m_pView->ShowClientNicks(unit.GetParam()+" "+unit.GetText());
		}
	};//SWITCH
};


void CChatCDoc::ConnectToServer()
{
	m_pClientSock=new CClientSock(this);

	if (m_pClientSock && !m_pClientSock->Create())
	{
		delete m_pClientSock;
		m_pClientSock=NULL;
		return;
	}

	if (!m_pClientSock->Connect(m_pView->m_sServerAddr, m_pView->m_nPortNb))
//	if (!m_pClientSock->Connect("localhost",9999))
	{
		delete m_pClientSock;
		m_pClientSock=NULL;
		return;
	}
}

void CChatCDoc::Disconnect()
{
	if (m_pClientSock)
	{
		m_pView->m_sSaid+="You are DISCONNECTED\r\n";
		m_pView->UpdateData(FALSE);
		delete m_pClientSock;
		m_pClientSock=NULL;
	}
}

void CChatCDoc::NickListRequest()
{
	if (m_pClientSock)
		m_pClientSock->SendString("LIST \r\n");
}
