// ChatCView.cpp : implementation of the CChatCView class
//

#include "stdafx.h"
#include "ChatC.h"

#include "ChatCDoc.h"
#include "ChatCView.h"
#include "DialogHelp.h"
#include "DialogConnect.h"
#include "DialogGreet.h"
#include "DialogChange.h"
#include "DialogJoin.h"
#include "ClientSock.h"
#include "ProtocolUnit.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CChatCView

IMPLEMENT_DYNCREATE(CChatCView, CFormView)

BEGIN_MESSAGE_MAP(CChatCView, CFormView)
	//{{AFX_MSG_MAP(CChatCView)
	ON_BN_CLICKED(IDC_HELP_BUTTON, OnHelpButtonClick)
	ON_BN_CLICKED(IDC_CHNICK_BUTTON, OnChnickButtonClick)
	ON_BN_CLICKED(IDC_CONNECT_BUTTON, OnConnectButtonClick)
	ON_BN_CLICKED(IDC_WHISPER_BUTTON, OnWhisperButton)
	ON_BN_CLICKED(IDC_DISCONNECT_BUTTON, OnDisconnectButton)
	ON_BN_CLICKED(IDC_SAY_BUTTON, OnSayButtonClick)
	ON_BN_CLICKED(IDC_JOIN_BUTTON, OnJoinButtonClick)
	ON_BN_CLICKED(IDC_BYE_BUTTON, OnByeButtonClick)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CChatCView construction/destruction

CChatCView::CChatCView()
	: CFormView(CChatCView::IDD)
{
	//{{AFX_DATA_INIT(CChatCView)
	m_say_edit = _T("");
	m_sSaid = _T("");
	m_nick_show = _T("");
	//}}AFX_DATA_INIT
	// TODO: add construction code here
}

CChatCView::~CChatCView()
{
}

void CChatCView::DoDataExchange(CDataExchange* pDX)
{
	CFormView::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CChatCView)
	DDX_Control(pDX, IDC_JOIN_BUTTON, m_join_control);
	DDX_Control(pDX, IDC_NICK_LIST, m_nick_list);
	DDX_Control(pDX, IDC_SAY_EDIT, m_say_control);
	DDX_Text(pDX, IDC_SAY_EDIT, m_say_edit);
	DDX_Text(pDX, IDC_SAID_EDIT, m_sSaid);
	DDX_Text(pDX, IDC_NICK_SHOW_EDIT, m_nick_show);
	DDV_MaxChars(pDX, m_nick_show, 10);
	//}}AFX_DATA_MAP
}

BOOL CChatCView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs
	
	return CFormView::PreCreateWindow(cs);
}

void CChatCView::OnInitialUpdate()
{
	CFormView::OnInitialUpdate();
	GetParentFrame()->RecalcLayout();
	ResizeParentToFit(FALSE);
	m_pDoc = GetDocument();
	ASSERT(m_pDoc!=NULL);
}

/////////////////////////////////////////////////////////////////////////////
// CChatCView diagnostics

#ifdef _DEBUG
void CChatCView::AssertValid() const
{
	CFormView::AssertValid();
}

void CChatCView::Dump(CDumpContext& dc) const
{
	CFormView::Dump(dc);
}

CChatCDoc* CChatCView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CChatCDoc)));
	return (CChatCDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CChatCView message handlers

void CChatCView::OnHelpButtonClick() 
{
	// TODO: Add your control notification handler code here
	CDialogHelp dlg;
	dlg.DoModal();
}

void CChatCView::OnChnickButtonClick() 
{
	// TODO: Add your control notification handler code here
	CDialogChange dlg;
	if ((m_pDoc->m_pClientSock!=NULL)&&(m_pDoc->m_pClientSock->IsJoined()))  //mozna zmienic nick jak sie jest connected
	{
		if (dlg.DoModal()==IDOK && (dlg.m_nick_edit.GetLength()>0))
		{
			
			CString sMesg;
			sMesg="NICK "+dlg.m_nick_edit+"\r\n";
			m_pDoc->m_sNickPropos=dlg.m_nick_edit;
			m_pDoc->m_pClientSock->SendString(sMesg);
		}
	}
	else if (!m_pDoc->m_pClientSock)
	{
		m_sSaid+="You aren't even CONNECTED. \r\n";
		UpdateData(FALSE);
	}
	else if ((m_pDoc->m_pClientSock)&&(m_pDoc->m_pClientSock->IsJoined()==FALSE))
	{
		m_sSaid+="You are CONNECTED but you have no nick. Use JOIN first.\r\n";
		UpdateData(FALSE);
	}

}

void CChatCView::OnConnectButtonClick() 
{
	if ((m_pDoc->m_bServer==TRUE) && (m_pDoc->m_bDownCmd==TRUE))
	{
		delete m_pDoc->m_pClientSock;
		m_pDoc->m_pClientSock=NULL;
	};
	if (m_pDoc->m_pClientSock==NULL)  //w razie jakby bedac connected probowla jeszcze raz
	{
		CDialogConnect dlg;
		if (dlg.DoModal()==IDOK)
		{
			m_nPortNb=dlg.m_port_edit;
			m_sServerAddr=dlg.m_server_edit;
			m_pDoc->ConnectToServer();						
			if (m_pDoc->m_pClientSock==NULL)			//!=NULL, connected
			{
				m_sSaid+="Couldn't connect to server.......  TRY AGAIN!\r\n";	
				UpdateData(FALSE);
			}	//if socket udalo sie 
		} //if IDOK
	}//socket==null
	else if (m_pDoc->m_pClientSock && (m_pDoc->m_bServer==TRUE))
	{
		m_sSaid+="You have already CONNECTED to server.\r\n";	
		UpdateData(FALSE);
	}
}


void CChatCView::ShowClientNicks(CString& sList)
{
	int nPos;
	CString sNick;

	m_nick_list.ResetContent(); // kasuje elementy listy
	
	nPos = sList.Find(' ');
	do
	{
		if(nPos == -1)
		{
			if(sList.GetLength()>0)
				m_nick_list.AddString(sList);
			return;
		}

		sNick = sList.Left(nPos);
		if(sNick.GetLength()>0)
			m_nick_list.AddString(sNick);
		sList = sList.Mid(nPos+1);
		nPos = sList.Find(' ');
	} while(nPos != -1);
}

void CChatCView::OnWhisperButton() 
{
	if ((m_pDoc->m_pClientSock)&&(m_pDoc->m_pClientSock->IsJoined()==TRUE))
	{
		if (UpdateData(TRUE))
		{
			CString nicksel;
			int pos;
			pos=m_nick_list.GetCurSel();
			m_nick_list.GetText(pos,nicksel);
			CString cMesg="WHISPER "+nicksel+" "+m_say_edit+ "\r\n";
			m_pDoc->m_pClientSock->SendString(cMesg);
			m_sSaid+="!!!<"+m_pDoc->m_pClientSock->GetClientNick()+">: "+m_say_edit+"\r\n";
			UpdateData(FALSE);
			m_say_edit="";
			UpdateData(FALSE);
			m_say_control.SetFocus();
		};
	}
	else if (!m_pDoc->m_pClientSock)
	{
		m_sSaid+="You can't WHISPER, you aren't CONNECTED.\r\n";
		UpdateData(FALSE);
	}
	else if ((m_pDoc->m_pClientSock)&&(m_pDoc->m_pClientSock->IsJoined()==FALSE))
	{
		m_sSaid+="You can't WHISPER, you haven't JOINED.\r\n";
		UpdateData(FALSE);
	}
}

void CChatCView::OnDisconnectButton() 
{
	if (m_pDoc->m_pClientSock)
	{
		m_pDoc->Disconnect();
		if (!m_pDoc->m_pClientSock)
			m_nick_list.ResetContent();
	}
	else
	{
		m_sSaid+="You are DISCONNECTED.\r\n";	
		UpdateData(FALSE);
	}
}

void CChatCView::WrongNickWasChosen()
{
	CDialogChange dlg;
	if(dlg.DoModal() == IDOK)
	{
		CString sMesg;
		if (m_pDoc->m_pClientSock && (m_pDoc->m_pClientSock->IsJoined()==TRUE))			
		{
			if(dlg.m_nick_edit.GetLength()>0)
			{
				sMesg="NICK "+dlg.m_nick_edit+"\r\n";
				m_pDoc->m_sNickPropos=dlg.m_nick_edit;	
				m_pDoc->m_pClientSock->SendString(sMesg);
			}
		}
		else if(m_pDoc->m_pClientSock && (m_pDoc->m_pClientSock->IsJoined()==FALSE))			
		{
			if(dlg.m_nick_edit.GetLength()>0)
			{
				sMesg="JOIN "+dlg.m_nick_edit+"\r\n";
				m_pDoc->m_sNickPropos=dlg.m_nick_edit;	
				m_pDoc->m_pClientSock->SendString(sMesg);
			}
		}
	}
	else if(dlg.DoModal() == IDCANCEL)
	{
		if(m_pDoc->m_pClientSock && (m_pDoc->m_pClientSock->IsJoined()==TRUE))			
		{
			m_sSaid+="Your NICK is unchanged.\r\n";
			UpdateData(FALSE);
		}
		if(m_pDoc->m_pClientSock && (m_pDoc->m_pClientSock->IsJoined()==FALSE))			
		{
			m_sSaid+="You haven't JOINED.\r\n";
			UpdateData(FALSE);
		}
	}
}

void CChatCView::OnSayButtonClick() 
{
	if ((m_pDoc->m_pClientSock!=NULL) && (m_pDoc->m_pClientSock->IsJoined()))
	{
		if (UpdateData(TRUE))
		{
			m_pDoc->m_pClientSock->SendString("SAY "+m_say_edit+"\r\n");				
			m_say_edit="";
			UpdateData(FALSE);
			m_say_control.SetFocus();
		}
	}
}

void CChatCView::OnJoinButtonClick() 
{
	if ((m_pDoc->m_pClientSock)&&(m_pDoc->m_pClientSock->IsJoined()==FALSE))
	{
		CDialogJoin dlg;
		if (dlg.DoModal()==IDOK)  //w dialogu trzeba zadbac, zeby nick byl ok
		{
			
			CString cMesg="JOIN "+dlg.m_sNickJoin+"\r\n";
			m_pDoc->m_pClientSock->SendString(cMesg);
			m_pDoc->m_sNickPropos=dlg.m_sNickJoin;
			m_pDoc->m_pClientSock->SetJoined(FALSE);
		}
	}
	else if(!m_pDoc->m_pClientSock)
	{
		m_sSaid+="First connect to server,then use JOIN.\r\n";	
		UpdateData(FALSE);
	}
	else if ((m_pDoc->m_pClientSock)&&(m_pDoc->m_pClientSock->IsJoined()==TRUE))
	{
		m_sSaid+="You have already JOINED. \r\n";	
		UpdateData(FALSE);
	}
}

void CChatCView::OnByeButtonClick() 
{
	if ((m_pDoc->m_pClientSock)&&(m_pDoc->m_pClientSock->IsJoined()==TRUE))
	{
		CString cMesg="BYE "+	m_pDoc->m_pClientSock->GetClientNick()+"\r\n";
		m_pDoc->m_pClientSock->SendString(cMesg);
		m_pDoc->m_pClientSock->SetJoined(FALSE);
		m_pDoc->m_pClientSock->SetClientNick("");
		m_sSaid+="Now you are away. \r\n";
		UpdateData(FALSE);
	}
	else if (!m_pDoc->m_pClientSock)
	{
		m_sSaid+="You aren't even CONNECTED. \r\n";
		UpdateData(FALSE);
	}
	else if ((m_pDoc->m_pClientSock)&&(m_pDoc->m_pClientSock->IsJoined()==FALSE))
	{
		m_sSaid+="You are CONNECTED but you haven't JOINED,noone hears you. \r\n";
		UpdateData(FALSE);
	}
}

